Subject: Re: bug#17156: [PATCH 2/5] Revert conversion to shell scripts

From: Paul Eggert <[email-masked]>
Date: Sat, 05 Apr 2014 15:57:27 -0700

Paolo Bonzini wrote:
> I'm not sure how this is not satisfied by the current code though.

I assume "current code" refers to the code that had egrep and fgrep 
executables (not shell scripts), i.e., commit d25bebd (2005-11-09) 
through commit 0995fc1 (2014-03-23).

Here's an example of why that approach made maintenance tricky.  When 
Norihiro changed fgrep to use the grep matcher (see Bug#16823), his 
patch would have broken fgrep -i due to code in main.c that did a STREQ 
(matcher, "fgrep") to see whether fixed matching was in effect -- this 
was incorrect when the executable was 'fgrep'.  I vaguely recall some 
other subtle bugs in the area and it was enough for me to throw up my 
hands and say "let's go back to the old way of doing things -- that's 
easier to maintain and more reliable".

If there's a porting problem with the new (i.e., the pre-2005) approach, 
there should be a way to fix the problem without having to cause 
maintenance hassles with grep proper.